//---------------------------------------------------------------------------

#include <vcl.h>
#include <iterator>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

class MyRandom {
  public:
    ptrdiff_t operator() (ptrdiff_t max) {
        double tmp;
        tmp = static_cast<double>(rand())
                / static_cast<double>(RAND_MAX);
        return static_cast<ptrdiff_t>(tmp * max);
    }
};


int main()
{
  vector<int> coll;

  INSERT_ELEMENTS(coll,1,9);
  PRINT_ELEMENTS(coll," :\n");

  //   
  random_shuffle (coll.begin(), coll.end());

  PRINT_ELEMENTS(coll,"  :\n");

  //  
  sort (coll.begin(), coll.end());
  PRINT_ELEMENTS(coll,":\n");

  //   
  //       
  //   -   l-    
  MyRandom rd;
  random_shuffle (coll.begin(), coll.end(),    // 
                  rd);                 //   

  PRINT_ELEMENTS(coll," :\n");


  getch();
  return 0;
}

//---------------------------------------------------------------------------